/*
Foilist v1.1 by Sheldor.  04/05/2024  1482 bytes
a minibot with wave surfing and pattern matching
v1.1 -- movement, energy management, targeting

Foil is one of the three forms of modern sport fencing,
along with épée and sabre.  https://en.wikipedia.org/wiki/Foil_%28fencing%29

Credits:
	Movement : jk.mini.CunobelinDC 1.2, simonton.mini.WeeksOnEnd 1.10.4, kc.micro.WaveShark 0.5
	Targeting: kc.micro.WaveShark 0.5
Also, a general thanks to all open source bot authors and contributors to the RoboWiki.

Foilist is released under the terms of the RoboWiki Public Code License (RWPCL) - Version 1.1.
see license here:  http://robowiki.net/wiki/RWPCL
*/

package sheldor.mini;

import robocode.*;
import robocode.util.Utils;
import java.awt.geom.*;     // for Point2D's
import java.lang.*;         // for Double and Integer objects
import java.util.ArrayList; // for collection of Waves
import java.awt.*;
import java.util.*;

public class Foilist extends AdvancedRobot {		

	static final int    GUESS_FACTORS = 100;
	static final int    MIDDLE_FACTOR = 16;

  private static final int MAX_BFT = 70;
  private static final int MAX_MATCH_LENGTH = 50;
  private static final double WALL_FEATURE = 0.45;
  
	private static final int SCAN_LENGTH = 48;
	private static final int VELOCITY_WEIGHT = (SCAN_LENGTH * 3) / 2;
	
	private static final int VELOCITY_VALUE = 1;

   static ArrayList hitScans = new ArrayList();
   
   public static Point2D.Double myLocation;    
   public static Point2D.Double enemyLocation;

   public static ArrayList enemyWaves;
   public static ArrayList pastWaves = new ArrayList();;

   public static double enemyEnergy;
   public static final double WALL_STICK = 160;
      
   static double lastLatVel;
   static double lastAdvVel;
   static double previousLastLatVel;
   static double lastPreviousLastLatVel;
   static double lastLatVelChange;
   
	static double waveCount;
		
	static double velocity;
	static double lastVelocity;
	static int ticksSinceVelocityChange;
	static int previousTicksSinceVelocityChange;
	static int ticksSinceHit;
	
	static double directionDistance;
	static double previousDirectionDistance;
	
//	static int historyIndex = (150000 - SCAN_LENGTH);
//	static double[] history = new double[150001];
	
	static double lastFactor;
	
//	static int[][] factors = new int[8][GUESS_FACTORS];
	
   public void run() {
      setAdjustGunForRobotTurn(true);
      setAdjustRadarForGunTurn(true);
    
      enemyWaves = new ArrayList();
     // pastWaves = new ArrayList();
	  
		//enemyEnergy = 102; 
		
	  setColors(java.awt.Color.white, java.awt.Color.black, java.awt.Color.lightGray);
   } 
   
   public void onStatus(StatusEvent e){    
      setTurnRadarRightRadians(1);
   }

   public void onScannedRobot(ScannedRobotEvent e) {
      	int i;   
      double absoluteBearing;  
      double enemyDistance;  
      double tempIndex;
	  double bearing;
      double latVel;
		double bulletPower;  
	  
      Wave ew;
	     
	  

	
		//wave surfing based on CunobelinDC's
		
      (ew = new Wave()).direction = (//direction =
 (int)Math.signum(//(direction / 100.0) +
	  
			(//history[--historyIndex] = 
			
(latVel = (getVelocity()*Math.sin(bearing = e.getBearingRadians())))) + 1E-10));
 //     double advVel = (getVelocity()*Math.cos(absoluteBearing));

			
	/*	if( direction != ((ew = new Wave()).direction = (direction = (int)Math.signum((direction / 100.0) +
			(latVel = (getVelocity()*Math.sin(absoluteBearing = e.getBearingRadians()))) + 1E-10)))){
			//previousDirectionDistance = directionDistance;
			//directionDistance = 0;
			
			previousTicksSinceVelocityChange = ticksSinceVelocityChange;
			ticksSinceVelocityChange = 0;
			}*/
   	
      setTurnRadarRightRadians(Utils.normalRelativeAngle((absoluteBearing = (bearing) + getHeadingRadians()) - getRadarHeadingRadians()) * 2);
	  
      pastWaves.add(0,ew);
    
      addWave(enemyEnergy - (enemyEnergy = e.getEnergy()));
   
     // update after EnemyWave detection, because that needs the previous
     // enemy location as the source of the Wave
      
      enemyLocation = project((myLocation = new Point2D.Double(getX(), getY())), (ew.directAngle = absoluteBearing), (enemyDistance = e.getDistance()));
   
   
      updateWaves();
	  
	
/*	double lowest = Double.POSITIVE_INFINITY;
tempIndex = (i = 3);

	do {
		double angle;
		double test;
		if ((test = checkDanger(
			angle = Math.cbrt(i) * (Math.PI/2))) < lowest){
			tempIndex = angle;
			lowest = test;
		}
	}
	while (--i >= -3);*/
	double lowest = Double.POSITIVE_INFINITY;
tempIndex = (i = 3);

	do {
		double angle;
		double test;
		if ((test = checkDanger(
			angle = Math.cbrt((i * //6.375
5//((35 / Math.cbrt(enemyDistance)))
) )// * 1.5
//(Math.PI/2)
)) < lowest){
			tempIndex = angle;
			lowest = test;
		}
	}
	while (--i >= -3);
//	while ((i -= 2) >= -4);
			
	/*	int[] wallScore = new int[3];
		i = 9;
		do{
			wallScore[Integer.signum(--i) + 1] += fieldContains(enemyLocation, (absoluteBearing + Math.PI) + (direction * (i / 10.0)), enemyDistance);
		}while(i > -8);*/
	
	//history = history.concat(String.valueOf((char)Math.round(latVel)));
//	history = String.valueOf((char)Math.round(latVel)).concat(history);
	

		//	int deceleration;
//	if ((deceleration = (velocity - (velocity = (int)Math.abs(getVelocity())))) != 0
	//	if (lastVelocity != (lastVelocity = velocity)
	if (velocity != (velocity = getVelocity())
//	if (getVelocity() == 0
){
			//previousTicksSinceVelocityChange = ticksSinceVelocityChange;
			ticksSinceVelocityChange = 0;//deceleration;
			}
	
	double distance;
	double[] localScan;// =// (ew.scan = new double[9]);
//(ew.scan = Arrays.copyOfRange(history, historyIndex - 8, historyIndex + SCAN_LENGTH));
	//(localScan = (ew.scan = new double[12]))[1] = pastWaves.size();//waveCount;
	(localScan = (ew.scan = new double[12]))[2] = lastLatVel;//lastPreviousLastLatVel;//previousLastLatVel ;
		//-	(localScan[3] = lastLatVel = Math.abs(latVel));//Math.abs(latVel);//lastLatVel;
	//localScan[2] = lastLatVel;
	//localScan[3] = velocity >> 2;
	localScan[3] = (lastLatVel = Math.abs(latVel));//lastPreviousLastLatVel = previousLastLatVel;//lastLatVelChange;//lastLatVel = Math.abs(latVel);
	localScan[7] = ((distance = enemyDistance));// / 250.0);
	//localScan[7] = (enemyDistance);
	localScan[8] = ++ticksSinceVelocityChange;//Math.cbrt(--ticksSinceVelocityChange);//VELOCITY_HISTORY_TABLE.charAt(ticksSinceVelocityChange += 3);
//	localScan[8] = lastFactor;
	//localScan[8] = ++ticksSinceVelocityChange / 15.0;//Math.cbrt(++ticksSinceVelocityChange);
	localScan[9] = velocity*Math.cos(bearing);//lastAdvVel;
	//localScan[10] = Integer.signum(--ticksSinceHit);
//	localScan[10] = Math.random() * deathCount;
	//distance = enemyDistance;
	//previousLastLatVel = lastLatVel;
//	lastLatVelChange = lastLatVel - (lastLatVel = Math.abs(latVel));

	//lastAdvVel = lastVelocity*Math.cos(bearing);//advVel;
	
			
	//lastLatVel = Math.abs((velocity = getVelocity())*Math.sin(bearing));
//ew.factors = factors[(int)lastLatVel];
   
/*      ew.scan = new double[]
         {0,waveCount,
(enemyDistance)*(1/250.0),//direction * (averageVelocity = ((averageVelocity * 31) + latVel) / 64),
//Math.cbrt(++ticksSinceVelocityChange), previousTicksSinceVelocityChange / 40.0,
//++ticksSinceVelocityChange / 20.0,// previousTicksSinceVelocityChange / 40.0,
lastLatVel, lastLatVel = Math.abs(latVel),
//(directionDistance += lastLatVel) / 80, previousDirectionDistance / 160,
			0,0,0
		//	wallScore[0], wallScore[2]
			};*/
			
//		int[] wallScore = new int[3];
		i = 5;
		do{
			localScan[5 - Integer.signum(--i)] += fieldContains(enemyLocation, (absoluteBearing + Math.PI) + (ew.direction * (i / 5.0)), enemyDistance);
		}while(i > -4);
      
	  	setAhead(0);
		if(tempIndex != 0){
		      double goAngle;
      setAhead(Math.cos(goAngle = 
wallSmoothing(myLocation, 
            absoluteBearing,
            tempIndex)
            - getHeadingRadians())/0);
      setTurnRightRadians(Math.tan(goAngle));
	  }
	 // else
{
		}	  

		//pattern matching based on kc.micro.WaveShark's
	   // Update log of enemy movements and pattern match
    enemyHistory = String.valueOf(
        (char)(
            ((int)Math.round(e.getVelocity() *
                Math.sin(e.getHeadingRadians() - absoluteBearing)) << 2)
            | (fieldContains(myLocation, absoluteBearing + WALL_FEATURE, enemyDistance) << 1)
            | fieldContains(myLocation, absoluteBearing - WALL_FEATURE, enemyDistance)
          )
        ).concat(enemyHistory);
		
    int matchLength = (int)(Math.ceil(Math.random() * MAX_MATCH_LENGTH));
	int matchPos; do{}
    while ((matchPos = enemyHistory.indexOf(
        enemyHistory.substring(0, (--matchLength)), MAX_BFT)) < 0);
		
	  do {
       absoluteBearing += Math.signum(enemyEnergy) * ((short)enemyHistory.charAt(--matchPos) >> 2) / enemyDistance;
	      } while ((distance -= Rules.getBulletSpeed(bulletPower = Math.min(enemyEnergy / 4,(210 / (int)enemyDistance)//(40 / Math.sqrt(enemyDistance)) 
			+ (BULLET_POWER_TABLE.charAt((int)getEnergy()) / 10.0)//+ (Math.cbrt(getEnergy() - 7) / 4))
))) > 0);
	//   } while ((distance -= Rules.getBulletSpeed(bulletPower = Math.min(enemyEnergy / 4,(400 / enemyDistance)//(40 / Math.sqrt(enemyDistance)) 
	//		+ (Math.cbrt(getEnergy() - 7) / 4)))) > 0);
//    } while ((distance -= Rules.getBulletSpeed(bulletPower = (getEnergy() > ((int)enemyDistance / 80)
//				? Math.min(enemyEnergy / 4, 15 / Math.cbrt(enemyDistance)) : 0))) > 0);
	
    setTurnGunRightRadians(Utils.normalRelativeAngle(
        ((Math.random() - 0.5) * 0.011) + absoluteBearing - getGunHeadingRadians()));
		
		if (getEnergy() > 0.21){
			setFire(bulletPower);
		}
   } 
    	
   public static void addWave(double deltaEnergy){		
		
      if (pastWaves.size() > 2 && (deltaEnergy > 0 || enemyWaves.isEmpty()
)){
		
         Wave ew;
         (ew = (Wave)pastWaves.get(2)).fireLocation = enemyLocation;
		 	
	/*  if (deltaEnergy > 0)// || enemyWaves.isEmpty())
      {		 
		ew.surf = ++waveCount;	
		enemyBulletSpeed = Rules.getBulletSpeed(deltaEnergy);
      }*/
	  	  ew.scan[11] = 1.5 * deltaEnergy;
		  ew.bulletVelocity = Rules.getBulletSpeed(deltaEnergy);
         enemyWaves.add(ew); 
		 waveCount++;// += Math.sqrt(Math.random());		
		 //random = Math.random(); 
	 // depth = (int)(hitScans.size() / (1.25 / Math.random())); 
	  }
   }

 // CREDIT: mini sized predictor from Apollon, by rozu
 // http://robowiki.net?Apollon

   public  double checkDanger(double direction) {
	   
	Wave wave;// = null;
	int waveIndex = 0;
	double totalScore = 0;
	
	try{
	while(true){
	//Iterator it = enemyWaves.iterator();
//	while (it.hasNext()){
//  while (waveIndex < enemyWaves.size()){
	//	if ((wave = (Wave)it.next()).surf > 0)
	{
      Point2D.Double predictedPosition = myLocation;
      double predictedVelocity = getVelocity();
      double predictedHeading = getHeadingRadians();
      double moveAngle, moveDir;
      
      int counter = 0; // number of ticks in the future
	  
	  //wave = (Wave)enemyWaves.get(waveIndex);//(Wave)enemyWaves.get(waveIndex);
      do {
	  	 if(direction != 0){
		  moveDir = 1;
			 
         if(Math.cos(moveAngle = wallSmoothing(predictedPosition,
			 absoluteBearing(predictedPosition,enemyLocation), direction) - predictedHeading) < 0) {
            moveAngle += Math.PI;
            moveDir = -1;
         }
      
       predictedPosition = project(predictedPosition,
            predictedHeading +=
            posNegLimit(Utils.normalRelativeAngle(moveAngle),
              Rules.getTurnRateRadians(Math.abs(predictedVelocity)))
             ,
              predictedVelocity = posNegLimit(predictedVelocity += (predictedVelocity * moveDir < 0 ? 2*moveDir : moveDir), 8)
              );
		}
            
      } while(predictedPosition.distance((wave = (Wave)enemyWaves.get(waveIndex)).fireLocation)
      > wave.distanceTraveled + ++counter*wave.bulletVelocity);
	  
	  predictedVelocity = 1 - (predictedHeading = getFactor(wave, predictedPosition));
	  //predictedHeading = getFactor(wave,predictedPosition);
	  waveIndex++;
      if(wave.dist > (wave.bulletVelocity-22)){
		 // int i = 0;//depth;
		 // try{
		//	while(true){
         Iterator i = hitScans.iterator();
         while(i.hasNext()){
            double[] scan = (double[])//hitScans.get(i);
i.next();
            double dist = (1/4000.0);
			int j = 2;
			do{
               dist += Math.pow((wave.scan[j] - scan[j])  / (double)WEIGHT_TABLE.charAt(j)
, 2
);
            }
			while(++j < scan.length);
			 predictedVelocity += (scan[1]//Math.pow(scan[1], random)
/(dist*(//0.25
//random
(1.0/50) 
+ Math.abs(predictedHeading - scan[0]))));
			//i++;
            }
			//}catch(Exception ex){}
    	totalScore += ((predictedVelocity) / predictedPosition.distanceSq(enemyLocation)) / Math.pow(waveIndex, 2);
   // 	totalScore += predictedVelocity / Math.pow(predictedPosition.distance(enemyLocation) * (wave.dist + 150), 2);			  
      }
	  }
	  }
	}
	catch(Exception ex){}
	  return totalScore;
   }   

 // CREDIT: Iterative WallSmoothing by Kawigi
 //   - return absolute angle to move at after account for WallSmoothing
 // robowiki.net?WallSmoothing
   public static double wallSmoothing(Point2D.Double botLocation, double angle, double orientation) {
	   angle += orientation;
	   do{}
	   while (fieldContains(botLocation,( angle -= orientation*0.025)
		 , WALL_STICK) > 0);
      return angle;
   }
   
   public static void updateWaves() {
      Wave ew;
	  int i = 0;//enemyWaves.size();
   //   Iterator it = enemyWaves.iterator();
      
		try{
			while(true){
    //  while(it.hasNext()) {         
         
         if (((ew = (Wave)enemyWaves.get(i)).dist = 
		 myLocation.distance(ew.fireLocation)
   	 	  - (ew.distanceTraveled += ew.bulletVelocity )
         ) < -50) {
			// ew.factors[(int)getFactor(ew,myLocation)] += waveCount;
			// lastFactor = getFactor(ew,myLocation);

			enemyWaves.remove(i);
           // it.remove();
            continue;
         }		
		 i++; 
      }
	  }
	  catch(Exception ex){}
   }

 // Given the EnemyWave that the bullet was on, and the point where we
 // were hit, calculate the index into our stat array for that factor.
   public static double getFactor(Wave ew, Point2D.Double targetLocation) {
	//  return Utils.normalRelativeAngle(absoluteBearing(targetLocation, ew.fireLocation) - ew.directAngle) * ew.direction
   //      /  Math.asin(8.0/ew.bulletVelocity);
      return //(MIDDLE_FACTOR + 25) + 
(//MIDDLE_FACTOR * 
(Utils.normalRelativeAngle(absoluteBearing(targetLocation, ew.fireLocation) - ew.directAngle) * ew.direction
         /  Math.asin(8.0/ew.bulletVelocity)));
   }

   public void onBulletHitBullet(BulletHitBulletEvent e){
      logEnemyBullet(e.getHitBullet());
   }
   public void onHitByBullet(HitByBulletEvent e) {
     
      logEnemyBullet(e.getBullet());
      enemyEnergy += 20 - e.getVelocity();
	  //ticksSinceHit = 127;
	 // random = Math.round(3.0 * Math.random());//(1.0/30.0) * Math.sqrt(Math.random());
	  //System.out.println(1.0/random);
   }
   public void onBulletHit(BulletHitEvent e){
      enemyEnergy -= Rules.getBulletDamage(e.getBullet().getPower());
   }
  /* public void onDeath(DeathEvent e)
	{	
		deathCount++;
	}  */
   public static void logEnemyBullet(Bullet b){
            // look through the EnemyWaves, and find one that could've hit us.
      Point2D.Double hitLocation; 
	  int i = 0;//enemyWaves.size();
     // Iterator it = enemyWaves.iterator();
	  try{
      while (true) {
         Wave ew;
         
         if (Math.abs((ew = (Wave)enemyWaves.get(i)).distanceTraveled
			 - (hitLocation =  new Point2D.Double(b.getX(), b.getY())).distance(ew.fireLocation)) <= 40) {
			ew.scan[0] = getFactor(ew, hitLocation);
			


			
			ew.scan[1] = waveCount;// * (1 + b.getPower());
			


			
            hitScans.add(ew.scan);	
			
             // We can remove this wave now, of course.
			 enemyWaves.remove(i);
            //it.remove();
         }
		 i++;
      }
	  }  
	  catch(Exception ex){} 
   }

 // This can be defined as an inner class if you want.
   static class Wave {
      Point2D.Double fireLocation;
      int direction;
	//  int surf;
      double[] scan;
	//  int[] factors;
	  double dist;
      double bulletVelocity, directAngle, distanceTraveled;
	  
		
 // Given the EnemyWave that the bullet was on, and the point where we
 // were hit, calculate the index into our stat array for that factor.
/*   private double getFactor(Point2D.Double targetLocation) {
	//  return Utils.normalRelativeAngle(absoluteBearing(targetLocation, ew.fireLocation) - ew.directAngle) * ew.direction
   //      /  Math.asin(8.0/ew.bulletVelocity);
      return //(MIDDLE_FACTOR + 25) + 
(//MIDDLE_FACTOR * 
(Utils.normalRelativeAngle(absoluteBearing(targetLocation, fireLocation) - directAngle) * direction
         /  Math.asin(8.0/bulletVelocity)));
   }*/
   }

 // CREDIT: from CassiusClay, by PEZ
 //   - returns point length away from sourceLocation, at angle
 // robowiki.net?CassiusClay
   public static Point2D.Double project(Point2D.Double sourceLocation, double angle, double length) {
      return new Point2D.Double(sourceLocation.x + Math.sin(angle) * length,
         sourceLocation.y + Math.cos(angle) * length);
   }

 // got this from RaikoMicro, by Jamougha, but I think it's used by many authors
 //  - returns the absolute angle (in radians) from source to target points
   public static double absoluteBearing(Point2D.Double source, Point2D.Double target) {
      return Math.atan2(target.x - source.x, target.y - source.y);
   }

   public static double posNegLimit(double value, double max) {
      return Math.max(-max, Math.min(value, max));
   }
   
	 private static int fieldContains(Point2D.Double source, double heading, double distance) {
    return Integer.signum(new Rectangle2D.Double(18, 18, 764, 564).outcode(
        project(source, heading, distance)));
  }
  
	static final String WEIGHT_TABLE = ""
	/*+ (char)1 + (char)1 + (char)2 + (char)1 
	+ (char)1 + (char)1 + (char)2 + (char)250 
	+ (char)12 + (char)2 + (char)1 + (char)1*/
	+ (char)1 + (char)1 + (char)1 + (char)1 
	+ (char)1 + (char)1 + (char)2 + (char)250 
	+ (char)12 + (char)2 + (char)1 + (char)1
	
	+ (char)(VELOCITY_WEIGHT + 1) + (char)(VELOCITY_WEIGHT + 2) 
	+ (char)(VELOCITY_WEIGHT + 3) + (char)(VELOCITY_WEIGHT + 4) 
	+ (char)(VELOCITY_WEIGHT + 5) + (char)(VELOCITY_WEIGHT + 6) 
	+ (char)(VELOCITY_WEIGHT + 7) + (char)(VELOCITY_WEIGHT + 8) 
	
	+ (char)(VELOCITY_WEIGHT + 8) + (char)(VELOCITY_WEIGHT + 10) 
	+ (char)(VELOCITY_WEIGHT + 11) + (char)(VELOCITY_WEIGHT + 12) 
	+ (char)(VELOCITY_WEIGHT + 13) + (char)(VELOCITY_WEIGHT + 14) 
	+ (char)(VELOCITY_WEIGHT + 15) + (char)(VELOCITY_WEIGHT + 16) 
	
	+ (char)(VELOCITY_WEIGHT + 17) + (char)(VELOCITY_WEIGHT + 18) 
	+ (char)(VELOCITY_WEIGHT + 19) + (char)(VELOCITY_WEIGHT + 20) 
	+ (char)(VELOCITY_WEIGHT + 21) + (char)(VELOCITY_WEIGHT + 22) 
	+ (char)(VELOCITY_WEIGHT + 23) + (char)(VELOCITY_WEIGHT + 24) 
	
	+ (char)(VELOCITY_WEIGHT + 25) + (char)(VELOCITY_WEIGHT + 26) 
	+ (char)(VELOCITY_WEIGHT + 27) + (char)(VELOCITY_WEIGHT + 28) 
	+ (char)(VELOCITY_WEIGHT + 29) + (char)(VELOCITY_WEIGHT + 30) 
	+ (char)(VELOCITY_WEIGHT + 31) + (char)(VELOCITY_WEIGHT + 32)

 	+ (char)(VELOCITY_WEIGHT + 33) + (char)(VELOCITY_WEIGHT + 34) 
	+ (char)(VELOCITY_WEIGHT + 35) + (char)(VELOCITY_WEIGHT + 36) 
	+ (char)(VELOCITY_WEIGHT + 37) + (char)(VELOCITY_WEIGHT + 38) 
	+ (char)(VELOCITY_WEIGHT + 39) + (char)(VELOCITY_WEIGHT + 40) 

 	+ (char)(VELOCITY_WEIGHT + 41) + (char)(VELOCITY_WEIGHT + 42) 
	+ (char)(VELOCITY_WEIGHT + 43) + (char)(VELOCITY_WEIGHT + 44) 
	+ (char)(VELOCITY_WEIGHT + 45) + (char)(VELOCITY_WEIGHT + 46) 
	+ (char)(VELOCITY_WEIGHT + 47) + (char)(VELOCITY_WEIGHT + 48) 
	
 	+ (char)(VELOCITY_WEIGHT + 49) + (char)(VELOCITY_WEIGHT + 50) 
	+ (char)(VELOCITY_WEIGHT + 51) + (char)(VELOCITY_WEIGHT + 52) 
	+ (char)(VELOCITY_WEIGHT + 53) + (char)(VELOCITY_WEIGHT + 54) 
	+ (char)(VELOCITY_WEIGHT + 55) + (char)(VELOCITY_WEIGHT + 56) 
	
	+ VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT
	+ VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT
	+ VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT
	
	+ VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT
	+ VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT
	+ VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT
	+ VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT	
	
	+ VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT
	+ VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT
	+ VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT
	+ VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT	
	
	+ VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT
	+ VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT
	+ VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT
	+ VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT + VELOCITY_WEIGHT
	
	+ (char)64 + (char)64 + (char)64 + (char)64
	+ (char)64 + (char)64 + (char)64 + (char)64
	+ (char)64 + (char)64 + (char)64 + (char)64
	+ (char)64 + (char)64 + (char)64 + (char)64
	
	+ (char)64 + (char)64 + (char)64 + (char)64
	+ (char)64 + (char)64 + (char)64 + (char)64
	+ (char)64 + (char)64 + (char)64 + (char)64
	+ (char)64 + (char)64 + (char)64 + (char)64
	
	+ (char)64 + (char)64 + (char)64 + (char)64
	+ (char)64 + (char)64 + (char)64 + (char)64
	+ (char)64 + (char)64 + (char)64 + (char)64
	+ (char)64 + (char)64 + (char)64 + (char)64;
  
	//tables for energy management
	static final String BP30 = ""
	+ (char)30 + (char)30 + (char)30 + (char)30
	+ (char)30 + (char)30 + (char)30 + (char)30
	+ (char)30 + (char)30 + (char)30 + (char)30
	+ (char)30 + (char)30 + (char)30 + (char)30
	+ (char)30 + (char)30 + (char)30 + (char)30
	+ (char)30 + (char)30 + (char)30 + (char)30
	+ (char)30 + (char)30 + (char)30 + (char)30
	+ (char)30 + (char)30 + (char)30 + (char)30
	+ (char)30 + (char)30 + (char)30 + (char)30
	+ (char)30 + (char)30 + (char)30 + (char)30
	+ (char)30 + (char)30 + (char)30 + (char)30
	+ (char)30 + (char)30 + (char)30 + (char)30;	
	
	static final String BULLET_POWER_TABLE = ""
	+ (char)1 + (char)3 + (char)3 + (char)3
	+ (char)3 + (char)3 + (char)3 + (char)3
	+ (char)3 + (char)3 + (char)3 + (char)3	
	+ (char)3 + (char)3 + (char)3 + (char)3
	+ (char)3 + (char)3 + (char)3 + (char)3
	+ (char)3 + (char)3 + (char)3 + (char)3
	
	+ (char)15 + (char)15 + (char)15 + (char)15
	+ (char)15 + (char)15 + (char)15 + (char)15
	+ (char)15 + (char)15 + (char)15 + (char)15
	+ (char)15 + (char)15 + (char)15 + (char)15
	+ (char)15 + (char)15 + (char)15 + (char)15
	+ (char)15 + (char)15 + (char)15 + (char)15
	+ (char)15 + (char)15
	
	+ (char)20 + (char)20 + (char)20 + (char)20
	+ (char)20 + (char)20 + (char)20 + (char)20
	+ (char)20 + (char)20 + (char)20 + (char)20
	+ (char)20 + (char)20 + (char)20 + (char)20
	+ (char)20 + (char)20 + (char)20 + (char)20
	+ (char)20 + (char)20 + (char)20 + (char)20
	+ (char)20 + (char)20 + (char)20 + (char)20
	+ (char)20 + (char)20 + (char)20 + (char)20
	+ (char)20 + (char)20 + (char)20 + (char)20
	+ (char)20 + (char)20 + (char)20 + (char)20
	+ (char)20 + (char)20 + (char)20 + (char)20
	+ (char)20 + (char)20
	
	+ (char)25 + (char)25 + (char)25 + (char)25
	+ (char)25 + (char)25 + (char)25 + (char)25
	+ (char)25 + (char)25 + (char)25 + (char)25
	
	+ (char)25 + (char)25 + (char)26 + (char)26
	+ (char)27 + (char)27 + (char)28 + (char)28
	+ (char)29 + (char)29 + (char)30 + (char)30
	
	+ BP30 + BP30 + BP30 + BP30 + BP30 + BP30 + BP30
	+ BP30 + BP30 + BP30 + BP30 + BP30 + BP30 + BP30
	+ BP30 + BP30 + BP30 + BP30 + BP30 + BP30 + BP30
	+ BP30 + BP30 + BP30 + BP30 + BP30 + BP30 + BP30
	+ BP30 + BP30 + BP30 + BP30 + BP30 + BP30 + BP30;
	
 // log of enemy movement, initialize to something to avoid out-of-bounds
  static String enemyHistory = "" +
      (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 +
      (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 +
      (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 +
      (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 +
      (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 +
      (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 +
      (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 +
      (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 +
      (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 +
      (char)0 + (char)3 + (char)0 + (char)-3 + (char)0 + (char)3 + (char)0 + (char)-3 + (char)0;
}
